/**********************************************************************************************************************

 AUFGABENBLATT 6 für alle Übungsgruppen - Allgemeine Informationen

 Das Projekt Aufgabenblatt6 besteht aus fünf Aufgaben in den Klassen Aufgabe1 bis Aufgabe5, die Sie erweitern und in
 den Übungen vom 8.6. bis 12.6. präsentieren müssen.

 Die Beantwortung von Fragen, die mit [fortgeschritten] gekennzeichnet sind, ist für fortgeschrittene Gruppen
 *verpflichtend*. Für andere Teilnehmer sind diese Fragen (obwohl empfohlen) freiwillig. Sind Sie in einer
 fortgeschrittenen Gruppe werden Kreuzerl, in denen [fortgeschritten] nicht berücksichtigt wurde, aberkannt.

 Achten Sie bei der Implementierung von Aufgabe1 bis Aufgabe5 auf folgende Punkte:

 - Ändern Sie nur die Klassen Aufgabe1 bis Aufgabe5, lassen Sie alle anderen Klassen des Projekts unverändert.
 - Ihr Programm sollte den dazugehörenden Test (z.B. enthält Aufgabe1Test den Test zu Aufgabe1) bestehen.
 - Sie dürfen den Test zu einer Aufgabe nicht (!) verändern, da Sie sonst beim Übersetzen falsche Meldungen bekommen.
 - Bei jeder Aufgabe finden Sie Zusatzfragen. Diese Zusatzfragen beziehen sich thematisch auf das erstellte Programm.
   Sie müssen diese Zusatzfragen in der Übung beantworten können.
 - Verwenden Sie zur Ausgabe immer System.out.println().
 - Verwenden Sie keine speziellen Aufrufe aus der Java-API, die die Aufgaben vereinfachen würden.

 Abgabe:  Die Abgabe muss bis Sonntag, den 7.6. um 13:59 erfolgen. Alle Änderungen am Projekt in der
 Übungsumgebung, die bis zu diesem Zeitpunkt von Ihnen vorgenommen wurden, werden als Abgabe betrachtet.

 ***********************************************************************************************************************/

/*
    Aufgabe1) Listen

    In der Klasse IntList haben Sie eine Listenimplementierung gegeben. Dazu sollen Sie folgende zusätzliche Methoden
    implementieren:

    - search:   (iterativ) Sucht in der Liste nach einem übergebenen Wert. Wird der Wert gefunden, dann wird true zurückgeliefert.
                Ansonsten wird false zurückgeliefert. Diese Methode muss iterativ in der Klasse IntList implementiert werden.
    - reverseI: (iterativ) Dreht die Liste um. Die Methode muss iterativ implementiert werden. Die eigentliche Iteration sollte in der
                Klasse ListNode durchgeführt werden. Bei dieser Methode werden keine (!) neuen Knoten erzeugt und die Werte
                der Knoten dürfen nicht überschrieben werden. Die Umkehrung der Liste wird nur durch die Neuverkettung der
                vorhandenen Knoten erreicht!
    - reverseR: (rekursiv) Dreht die Liste um. Die Methode muss rekursiv implementiert werden. Die eigentliche Rekursion sollte in
                der Klasse ListNode durchgeführt werden. Bei dieser Methode werden keine (!) neuen Knoten erzeugt und die
                Werte der Knoten dürfen nicht überschrieben werden. Die Umkehrung der Liste wird nur durch die Neuverkettung
                der vorhandenen Knoten erreicht!
    - remove:   (iterativ) Entfernt aus der Liste einen übergebenen Wert, falls dieser vorhanden ist. Bei erfolgreichem Entfernen
                wird true zurückgegeben, ansonsten false.

    [fortgeschritten]
    Erweitern Sie ListNode um eine Membervariable "int prevSum" (previous sum), die die Summe aller vorherigen Elemente der Liste abspeichert,
    und diese bei Veränderung der Liste durch die oben angeführten Methoden wieder aktualisiert und anpasst. Der head-Knoten
    der Liste hat für prevSum den Wert 0 gespeichert.

    Zusatzfragen:
    1. Wie entsteht die Ausgabe beim Aufruf der Methode System.out.println(list);
    2. Warum ist es sinnvoll beim Iterieren durch Listen sich eine Kopie des Zeigers auf den "head"-Knoten zu erstellen?
    3. Erläutern Sie die Vor- und Nachteile von Listen gegenüber Arrays.
*/

class IntList {

    private class ListNode {
        int elem;
        ListNode next = null;

        ListNode(int elem, ListNode next) {
            this.elem = elem;
            this.next = next;
        }

        int getElem() {
            return this.elem;
        }

        ListNode getNext() {
            return this.next;
        }

        void add(int elem) {
            if (this.next == null) {
                this.next = new ListNode(elem, null);
            } else {
                this.next.add(elem);
            }
        }

        ListNode reverseI() {
            /* TODO: add code here */
            //liste leer, oder nur 1 element
            if (this == null || this.next == null)
                return this;

            ListNode result = null;
            ListNode current = head;

            do {
                ListNode temp = new ListNode(current.getElem(), result);
                result = temp;
                current = current.getNext();
            } while (current != null);

            System.err.println(result);
            return result;
        }

        ListNode reverseR() {
            /* TODO: add code here */
            //Liste leer, oder nur 1 element
            if (this == null || this.next == null)
                return this;

            ListNode snd = this.getNext();
            this.next = null;

            ListNode reversed = snd.reverseR();

            snd.next = this;

            return reversed;
            /* kürzer/Alternative:
            if (this.next == null(
                return this;

            ListNode sorted = next.reversR();

            next.next = this;
            next = null;

            return sorted
             */
        }

        public String toString() {
            return this.elem + ((this.next == null) ? "-|" : "->" + this.next);
        }

    }

    private ListNode head = null;

    public boolean empty() {
        return this.head == null;
    }

    public void add(int elem) {
        if (this.empty()) {
            this.head = new ListNode(elem, null);
        } else {
            this.head.add(elem);
        }
    }

    public boolean search(int value) {
        /* TODO: add code here */
        if (this.head == null)
            return false;

        ListNode pointer = this.head;

        while (pointer != null) {
            if (pointer.getElem() == value)
                return true;
            pointer = pointer.getNext();
        }
        return false;
    }

    public boolean remove(int value) {
        /* TODO: add code here */
        //erstes Element entspricht value
        if (this.head.getElem() == value) {
            this.head = this.head.getNext();
            return true;
        }

        for (ListNode current = head; current.getNext() != null; current = current.getNext()) {
            if (current.getNext().getElem() == value) {
                current.next = current.getNext().getNext();
                return true;
            }
        }
        return false;
    }

    public int first() {
        return this.head.getElem();
    }

    public void reverseI() {
        /* TODO: add code here */
        head = head.reverseI();
    }

    public void reverseR() {
        /* TODO: add code here */
        System.err.println(head.toString());
        head = head.reverseR();
        System.err.println(head.toString() + " (reversed)");
    }

    public String toString() {
        return "[" + this.head + "]";
    }
}

public class Aufgabe1 {

    // just for testing ...
    public static void main(String[] args) {
        // Implementierung von main wird nicht beurteilt
        IntList intL1 = new IntList();
        intL1.add(1);
        intL1.add(2);
        intL1.add(3);
        System.out.println(intL1.toString());
        System.out.println(intL1.search(3));
    }
}
