import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.Timeout;
import java.lang.reflect.Method;
import java.util.Arrays;

import static org.junit.Assert.assertEquals;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;
import static org.junit.Assert.assertTrue;

public class Aufgabe2Test {

    @Rule
    public Timeout globalTimeout = new Timeout(1500);

    @Test
    public void testSort() throws Exception {
        int n = 100000;
        int[] array1 = new int[n];
        for (int i = 0; i < n; i++) {
            array1[i] = (int) (Math.random() * (n - i));
        }
        Method method = Aufgabe2.class.getDeclaredMethod("sort", int[].class);
        method.setAccessible(true);
        Aufgabe2.sort(array1);
        for (int i : array1) {
            int res = Arrays.binarySearch(array1, i);
            assertTrue("Sequence not sorted!", res >= 0);
        }
    }

    @Test
    public void testBinSearch() throws Exception {
        int n = 100000;
        int[] array1 = new int[n];
        for (int i = 0; i < n; i++) {
            array1[i] = (int) (Math.random() * (n - i));
        }
        Method method = Aufgabe2.class.getDeclaredMethod("binSearch", int[].class, int.class);
        method.setAccessible(true);
        Arrays.sort(array1);
        for (int i : array1) {
            assertThat("Binary search failed!", Aufgabe2.binSearch(array1, i), is(true));
        }
        int[] array2 = {};
        assertThat("Binary search failed!", Aufgabe2.binSearch(array2, 99), is(false));
    }
}
